﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace ASPNETMVCAjaxFetchHtmlForms.Controllers
{
    public class AjaxController : Controller
    {
        [Route("/html-form")]
        [HttpPost]
        //[HttpPut]
        [ValidateAntiForgeryToken]
        public IActionResult FormPostPut(RecvData recvData)
        {
            // Прямой способ получения данных формы.
            var httpRequest = HttpContext.Request;
            //string nameProduct = httpRequest.Form["nameProduct"].ToString();

            // Место кода валидации данных.
            if (recvData.NameProduct == null || recvData.NameProduct.Length > 250)
            {
                return Content("Incorrect data");
            }

            // Использование проверенных данных.

            // Отправка отклика успешности
            return Content("Ok");
        }

        [Route("/html-form-manually")]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult FormManually(RecvData recvData)
        {
            var httpRequest = HttpContext.Request;

            // Место кода валидации данных.
            if (recvData.NameProduct == null && recvData.DescriptionProduct == null)
            {
                return Content("Incorrect data");
            }


            return Content(recvData.NameProduct + "=" + recvData.DescriptionProduct);
        }

        [Route("/html-form-get")]
        [HttpGet]
        [ValidateAntiForgeryToken]
        public IActionResult FormGet(RecvData recvData)
        {
            var httpRequest = HttpContext.Request;

          
            return Content("Ok");
        }

        public class RecvData
        {
            public string? NameProduct { get; set; }
            public string? DescriptionProduct { get; set; }
            public string? Pack { get; set; }
            public string? Delivery { get; set; }
            public string? Color { get; set; }
            public IFormFile? PhotoProduct { get; set; }
        }
    }
}
